import pandas as pd
from typing import List
import ast

def merge_dataset(X: pd.DataFrame, Y: pd.DataFrame, on: str):
    merged_dataset = X.merge(Y, on=on)
    return merged_dataset

def subset_dataframe(X: pd.DataFrame, variables: List[str]):
    return X[variables]

def convert(text):
    L = []
    for i in ast.literal_eval(text):
        L.append(i['name']) 
    return L 

def fetch_director(text):
    L = []
    for i in ast.literal_eval(text):
        if i['job'] == 'Director':
            L.append(i['name'])
    return L 

def convert_dataset(X: pd.DataFrame, convert_variables: List[str], top_3_variables: List[str], fetch_dir_variable: str):
    for variable in convert_variables:
        X[variable] = X[variable].apply(convert)
    X[top_3_variables] = X[top_3_variables].apply(lambda x:x[0:3])
    X[fetch_dir_variable] = X[fetch_dir_variable].apply(fetch_director)
    return X

def collapse(L):
    L1 = []
    for i in L:
        L1.append(i.replace(" ",""))
    return L1

def collapse_dataset(X: pd.DataFrame, variables: List[str]):
    for variable in variables:
        X[variable] = X[variable].apply(collapse)
    return X

def split_dataset(X: pd.DataFrame, variable: str):
    X[variable] = X[variable].apply(lambda x:x.split())
    return X

def create_tags_variable(X: pd.DataFrame, new_variable: str, tag_variables: List[str]):
    X[new_variable] = X[tag_variables[0]]+X[tag_variables[1]]+X[tag_variables[2]]+X[tag_variables[3]]+X[tag_variables[4]]
    return X

def drop_variables(X: pd.DataFrame, variables:List[str]):
    return X.drop(columns=variables)

def create_new_tags(X: pd.DataFrame, variable:str):
    X[variable] = X[variable].apply(lambda x: " ".join(x))
    return X
